<!DOCTYPE html>
<div class="col-lg-12 animated fadeInRight">
  <div class="wrapper wrapper-content animated fadeInRight">
    <div class="row">
      <div class="col-lg-12">
        <div class="ibox float-e-margins">
          <div class="ibox-title">
            <h3>
              <strong>Manage Shifts</strong>
            </h3>
            <br />
            <div class="fm-row row">
              <div class="col-md-12">
                <div class="col-xs-3 autocomplete-field-container">
                  <input matInput placeholder="Select Shift Id" class="form-control" name="shift_id"
                    (ngModelChange)="searchShiftForId($event)" [(ngModel)]="shift_id" aria-label="shift"
                    [matAutocomplete]="shift">
                  <img *ngIf="loadingIndicator == 'searchShiftForId'" class="loading_indicator"
                    src="assets/img/loading.gif" alt="csv"/>
                  <mat-autocomplete #shift="matAutocomplete" [displayWith]="displayFnShift">
                    <mat-option *ngFor="let shift of ShiftIDData" [value]="shift">
                      <span>{{shift.unique_shift_id}}
                      </span>
                    </mat-option>
                    <mat-option *ngIf="ShiftIDData == '' && ShiftIDData.length == 0">No Matches Found</mat-option>
                  </mat-autocomplete>
                </div>
                <div class="col-xs-3 custom-position">
                  <input name="shift_start" [(ngModel)]="selectedMoment" (click)="checkShiftstartTime()"
                    class="form-control" [max]="max" [owlDateTimeTrigger]="dtPicker1" [owlDateTime]="dtPicker1"
                    placeholder="Shift Start Date">
                  <span>
                    <i aria-hidden="true" class="fa fa-calender" (click)="checkShiftstartTime()"></i>
                  </span>
                  <i aria-hidden="true" class="fa fa-calendar" style="font-size: 20px;float: right;" [owlDateTimeTrigger]="dtPicker1"
                    (click)="checkShiftstartTime()"></i>
                  <owl-date-time #dtPicker1></owl-date-time>
                </div>
                <div class="col-xs-3 custom-position">
                  <input [(ngModel)]="selectedMoment1" name="shift_end" [min]="selectedMoment" [max]="max2"
                    [owlDateTimeTrigger]="dtPicker2" [owlDateTime]="dtPicker2" placeholder="Shift End Date"
                    class="form-control">
                  <i aria-hidden="true" class="fa fa-calendar" style="font-size: 20px;float: right;" [owlDateTimeTrigger]="dtPicker2"
                    (click)="checkShiftstartTime1()"></i>
                  <owl-date-time #dtPicker2></owl-date-time>
                </div>
                <div class="col-xs-3">
                  <select [(ngModel)]="approve_status" name="approve_status" class="form-control" placeholder="status">
                    <option Value=""> Shift status</option>
                    <option Value="1"> Closed </option>
                    <option Value="2"> Open </option>
                  </select>
                </div>
              </div>
            </div>
            <div class="fm-row row">
              <div class="col-md-12">
                <div class="col-xs-3">
                  <select [(ngModel)]="empty_status" name="empty_status" class="form-control">
                    <option Value="">Shift type</option>
                    <option Value="0"> Empty </option>
                    <option Value="1"> Not Empty </option>
                  </select>
                </div>
                <div class="col-sm-3 autocomplete-field-container">
                  <input [(ngModel)]="driverIdForm" matInput [formControl]="driver_Id" placeholder="Employee id"
                    class="form-control" name="driveruniqueid" (ngModelChange)="searchDriverId($event)"
                    [matAutocomplete]="uniqueDid">
                  <img *ngIf="loadingIndicator == 'searchDriverId'" class="loading_indicator"
                    src="assets/img/loading.gif" alt="csv"/>
                  <mat-autocomplete #uniqueDid="matAutocomplete" [displayWith]="displayFnDriverId">
                    <mat-option *ngFor="let driverID of driverIdData" [value]="driverID">
                      <div class="option-otr">
                        <span>{{ driverID.emp_id}}</span>
                      </div>
                    </mat-option>
                    <mat-option *ngIf="driverIdData == '' && driverIdData.length == 0">No Matches Found</mat-option>
                  </mat-autocomplete>
                </div>
                <div class="col-xs-3">
                  <input [(ngModel)]="deviceForm" [formControl]="device" type="text" placeholder="Select device"
                    [matAutocomplete]="devices" class="form-control"
                    (ngModelChange)="searchDevice($event)">
                  <img *ngIf="loadingIndicator == 'searchDevice'" class="loading_indicator"
                    src="assets/img/loading.gif" alt="loader"/>
                  <mat-autocomplete #devices="matAutocomplete" [displayWith]="displayFnDevice">
                    <mat-option *ngFor="let device of deviceData" [value]="device">
                      <div class="option-otr">
                        <div class="option_span">{{device.unique_device_id}}</div>
                        <div class="option_span"> {{device.device_model}}</div>
                      </div>
                    </mat-option>
                    <mat-option *ngIf="deviceData == '' && deviceData.length == 0">No Matches Found</mat-option>
                  </mat-autocomplete>
                </div>
                <div class="col-xs-3 autocomplete-field-container">
                  <input [(ngModel)]="sideForm" matInput [formControl]="vehicle_side_no" placeholder="Select Vehicle No"
                    class="form-control" name="vehichle_side_no" (ngModelChange)="searchVehichleSidenumber($event)"
                    aria-label="vehichleSide" [matAutocomplete]="vehichleSide">
                  <img *ngIf="loadingIndicator == 'searchVehichleSidenumber'" class="loading_indicator"
                    src="assets/img/loading.gif" alt="loader"/>
                  <mat-autocomplete #vehichleSide="matAutocomplete" [displayWith]="displayFnVehichleSide">
                    <mat-option *ngFor="let vehichle1 of vehichleSideData" [value]="vehichle1">
                      <span>{{ vehichle1.vehicle_identity_number}}</span>
                    </mat-option>
                    <mat-option *ngIf="vehichleSideData == '' && vehichleSideData.length == 0">No Matches Found
                    </mat-option>
                  </mat-autocomplete>
                </div>
              </div>
            </div>
            <div class="fm-row row">
              <div class="col-md-12">
                <div class="col-sm-3 autocomplete-field-container">
                  <input [(ngModel)]="plateForm" matInput [formControl]="vehicle_plate_no"
                    placeholder="Select Plate Number" class="form-control" name="vehichle_plate_no"
                    (ngModelChange)="searchVehichlePlateNumber($event)" aria-label="VehichlePlate"
                    [matAutocomplete]="vehichlePlate">
                  <img *ngIf="loadingIndicator == 'searchVehichlePlateNumber'" class="loading_indicator"
                    src="assets/img/loading.gif" alt="loader"/>
                  <mat-autocomplete #vehichlePlate="matAutocomplete" [displayWith]="displayFnVehichlePlate">
                    <mat-option *ngFor="let vehichle2 of vehichlePlateData" [value]="vehichle2">
                      <div class="option-otr">
                        <span>{{ vehichle2.plate_number}}</span>
                      </div>
                    </mat-option>
                    <mat-option *ngIf="vehichlePlateData == '' && vehichlePlateData.length == 0">No Matches Found
                    </mat-option>
                  </mat-autocomplete>
                </div>
                <div class="col-xs-4">
                  <input [(ngModel)]="driverForm" [formControl]="queryField" type="text" placeholder="search for driver"
                    [matAutocomplete]="driver" class="form-control"
                    (ngModelChange)="searchDrivers($event)">
                  <img *ngIf="loadingIndicator == 'searchDrivers'" class="loading_indicator"
                    src="assets/img/loading.gif" alt="loader"/>
                  <mat-autocomplete #driver="matAutocomplete" [displayWith]="displayFnDriver">
                    <mat-option *ngFor="let driver of DriverData" [value]="driver">
                      <span class="img-otr">
                        <img style="vertical-align:middle;" aria-hidden
                          src="{{driver.profile_picture ? apiUrl + driver.profile_picture+imageext : '../../assets/img/noimage.jpg'}}"
                          height="25" alt="profile pic"/>
                      </span>
                      <div class="option-otr">
                        <div class="option_span">Username:
                          <strong>{{ driver.username }}</strong>
                        </div>
                        <div class="option_span">Name and Surname:
                          <strong>{{ driver.name }} &nbsp;{{ driver.surname }}</strong>
                        </div>
                        <div class="option_span">Display Name:
                          <strong>{{ driver.display_name }}</strong>
                        </div>
                      </div>
                    </mat-option>
                    <mat-option *ngIf="DriverData == '' && DriverData.length == 0">No Matches Found</mat-option>
                  </mat-autocomplete>
                </div>
                <div class="col-sm-2">
                  <select [(ngModel)]='pageSize' name='pageSize' class="form-control">
                    <option value="10">10 records</option>
                    <option value="20">20 records</option>
                    <option value="40">30 records</option>
                    <option value="50">50 records</option>
                  </select>
                </div>
                <div class="col-sm-3" *ngIf="dtc">
                  <mat-select [(ngModel)]="companyIdFilter" placeholder="Company" (change)="changeCompany()"
                    class="form-control" multiple>
                    <mat-option value="all" (click)="selectAllCompany()">All</mat-option>
                    <mat-option (click)="companyManualSelect()" *ngFor="let company of companyData" [value]="company._id">
                      {{company.company_name}}
                    </mat-option>
                  </mat-select>
                </div>
              </div>
              <div class="fm-row row">
                <div class="col-md-12">
                  <div class="col-md-7">
                    <div *ngIf="creatingcsv">
                      <progress-bar [progress]="progressvalue" [color]="'#211d46'">
                      </progress-bar>
                    </div>
                  </div>
                  <div class="col-md-5 text-right" style="cursor: pointer">
                    <ng-container *ngIf="downloads">
                      <span matTooltip="Shifts CSV">
                        <img src="assets/img/csv.png" (click)="getconstantsforcsv()" alt="csv"/>
                      </span>
                    </ng-container>
                    <button type="get" (click)="searchShifts();" class="btn btn-sm btn-primary blue">
                      <i aria-hidden="true" class="fa fa-search"></i>
                      Search
                    </button>
                    <button type="get" (click)="refetchShifts();" class="btn btn-sm btn-primary green">
                      <i aria-hidden="true" class="fa fa-refresh"></i>
                      Refresh
                    </button>
                    <button type="get" (click)="reset();" class="btn btn-sm red">
                      <i aria-hidden="true" class="fa fa-eraser"></i>
                      Reset filters
                    </button>
                  </div>
                </div>
              </div>
              <div id="google"></div>
              <div class="ibox-content" *ngIf="pageNo==0">
                  showing records {{pageNo+1}}-{{(pageNo+1)*pageSize}}/{{allShiftsLength}}
              </div>
              <div class="ibox-content" *ngIf="pageNo!==0">
                  showing records {{pageNo}}-{{((pageNo/pageSize+1)*pageSize)}}/{{allShiftsLength}}
              </div>
              <div class="payment-cal-outer" *ngIf="allShiftsLength > 0">
                <div class="payment-cal-table table-responsive">
                  <div style="float:right;border-left:1px dotted #fff;padding: 0 20px;">
                    <table aria-describedby="Manage Company" class="sum_table">
                      <span *ngIf="searchLoader">
                        <img alt="loader" src="assets/img/loader.gif" class="loader-img" />
                      </span>
                      <tbody>
                        <tr>
                          <th scope="col" class="sum_table_headers"></th>
                          <th scope="col" class="sum_table_headers">Count</th>
                          <th scope="col" class="sum_table_headers">Amount</th>
                        </tr>
                        <tr>
                          <th scope="col" class="sum_table_headers">Total</th>
                          <td>{{ shift_detail_data.total_bill_count?shift_detail_data.total_bill_count:'0' }}</td>
                          <td>{{ shift_detail_data.total_amount?shift_detail_data.total_amount:'0' }}</td>
                        </tr>
                        <tr class="total">
                          <th scope="col" class="sum_table_headers">Bill printed</th>
                          <td>{{shift_detail_data.bill_printed_count?shift_detail_data.bill_printed_count:'0'}}</td>
                          <td>{{shift_detail_data.bill_printed?shift_detail_data.bill_printed:'0'}}</td>
                        </tr>
                        <tr>
                          <th scope="col" class="sum_table_headers">Bill not printed</th>
                          <td>{{shift_detail_data.bill_notprinted_count?shift_detail_data.bill_notprinted_count:'0'}}
                          </td>
                          <td>{{shift_detail_data.bill_notprinted?shift_detail_data.bill_notprinted:'0'}}</td>
                        </tr>
                      </tbody>
                    </table>
                  </div>
                  <table aria-describedby="Manage Company">
                    <tbody>
                      <tr>
                        <th scope="col" class="sum_table_headers" colspan="2">By payment type</th>
                      </tr>
                      <tr>
                        <th scope="col">Credit</th>
                        <td style="text-align:right">
                          {{shift_detail_data.credit_trip_total?shift_detail_data.credit_trip_total:'0'}}</td>
                      </tr>
                      <tr>
                        <th scope="col">Cash</th>
                        <td style="text-align:right">
                          {{shift_detail_data.cash_trip_total?shift_detail_data.cash_trip_total:'0'}}</td>
                      </tr>
                      <tr>
                        <th scope="col">Account</th>
                        <td style="text-align:right">
                          {{shift_detail_data.account_total?shift_detail_data.account_total:'0'}}</td>
                      </tr>
                      <tr>
                        <th scope="col">Online</th>
                        <td style="text-align:right">
                          {{shift_detail_data.card_total?shift_detail_data.card_total:'0'}}</td>
                      </tr>
                      <tr>
                        <td>
                          <br>
                        </td>
                      </tr>
                      <tr>
                        <th scope="col" style="padding-bottom:10px" class="sum_table_headers">Trip total</th>
                        <td style="text-align:right;font-weight:bold;padding-bottom:10px">
                          {{shift_detail_data.total_amount?shift_detail_data.total_amount:'0'}}</td>
                      </tr>
                    </tbody>
                  </table>
                  <table aria-describedby="Manage Company" class="sum_table">
                    <tbody>
                      <tr>
                        <th scope="col" class="sum_table_headers" colspan="2">By payment extra</th>
                      </tr>
                      <tr *ngFor="let data of payment_extra">
                        <td>{{data.name}}</td>
                        <td> X {{data.count}}</td>
                        <td>{{data.amt.$numberDecimal}}</td>
                      </tr>

                      <tr>
                        <td>--------</td>
                        <td>--------</td>
                      </tr>
                    </tbody>
                  </table>
                </div>
              </div>

              <div class="ibox-content">
                <div class="table-responsive">
                  <table aria-describedby="Manage Company" class="table table-striped table-bordered table-responsive">
                    <thead>
                      <tr>
                        <th scope="col">Shift Id(Company),
                          <br> Duration,
                          <br> Login start/end</th>
                        <th scope="col">Occupied/free(hh:mm:ss),
                          <br> First start/last stop,
                          <br> Orders distance/ total distance</th>
                        <th scope="col">Driver / vehicle
                          <br>Vehicle Plate/
                          <br>Vehicle Side Number
                        </th>
                        <th scope="col">Bill / Free rides</th>
                        <th scope="col">Payment type</th>
                        <th scope="col">Payment extra</th>
                        <th scope="col">Total price</th>
                        <th scope="col">Total driver cash</th>
                        <th scope="col">Payed</th>
                        <th scope="col">To pay</th>
                        <th scope="col"> Action</th>
                      </tr>
                    </thead>
                    <tbody>
                      <span *ngIf="searchLoader">
                        <img alt="loader" src="assets/img/loader.gif" class="loader-img" />
                      </span>
                      <tr *ngFor="let shift of allShiftsData; let i = index" [attr.data-index]="i">
                        <td [ngClass]="{'expandedrowsbg': shift.expandedrows}">
                          {{shift.unique_shift_id}}
                          <br>(
                          <strong>{{shift.shift_details_id!=null ? shift.shift_details_id.company_id ?
                            shift.shift_details_id.company_id.company_name
                            : 'N/A' : 'Dubai Taxi'}}</strong>),
                          <span style="color:red;"> {{shift.empty_status =='0' ? 'Empty': ''}}</span>
                          <br>
                          <br>{{shift.shift_details_id!=null ? shift.shift_details_id.shift_duration ?
                          shift.shift_details_id.shift_duration
                          : 'N/A' : 'N/A'}},
                          <br>
                          <br> <span style="color:red;"
                            *ngIf="shift.shift_details_id && shift.shift_details_id.edit_flag && shift.shift_details_id.edit_flag==1">Edited
                            & Removed Shift from cashier</span>
                          <br> <span style="color:red;"
                            *ngIf="shift.shift_details_id && shift.shift_details_id.replaced_shift && shift.shift_details_id.replaced_shift==1">Newly
                            created after correction
                          </span>
                          <br>{{shift.shift_start ? shift.shift_start : 'N/A'}} / {{shift.shift_end ? shift.shift_end
                          :'Ongoing'}}
                          <button type="button" class="btn2" (click)="showInnerShifts(shift,i)"
                            *ngIf="!shift.selected && shift.shift_logs.length>0 && !shift.expandedrows">+</button>
                          <button type="button" class="btn2" (click)="showInnerShifts(shift,i)"
                            *ngIf="shift.selected && shift.shift_logs.length>0 && !shift.expandedrows">-</button>
                        </td>
                        <td>
                          {{shift.shift_details_id!=null ? shift.shift_details_id.occupied_time ?
                          shift.shift_details_id.occupied_time : 'N/A' : 'N/A'}}
                          / {{shift.shift_details_id!=null ? shift.shift_details_id.free_time ?
                          shift.shift_details_id.free_time
                          : 'N/A' : 'N/A'}},
                          <br>
                          <br>{{shift.shift_details_id!=null ? shift.shift_details_id.first_start ?
                          shift.shift_details_id.first_start
                          : 'N/A' : 'N/A'}} / {{shift.shift_details_id!=null ? shift.shift_details_id.last_stop ?
                          shift.shift_details_id.last_stop
                          : 'N/A' : 'N/A'}} ,
                          <br>
                          <br>{{shift.shift_details_id!=null ? shift.shift_details_id.orders_distance ?
                          shift.shift_details_id.orders_distance.$numberDecimal
                          : 'N/A' : 'N/A'}} / {{shift.shift_details_id!=null ? shift.shift_details_id.total_distance ?
                          shift.shift_details_id.total_distance.$numberDecimal
                          : 'N/A' : 'N/A'}}
                        </td>
                        <td>({{shift.driver_id!=null ? shift.driver_id.display_name ? shift.driver_id.display_name :
                          'N/A' : 'N/A'}}) {{shift.driver_id!=null
                          ? shift.driver_id.emp_id ? shift.driver_id.emp_id : 'N/A' : 'N/A'}} /
                          <br>
                          <br>({{shift.vehicle_id!=null ? shift.vehicle_id.vehicle_unique_id ?
                          shift.vehicle_id.vehicle_unique_id
                          : 'N/A' : 'N/A'}}) {{shift.vehicle_id!=null ? shift.vehicle_id.display_name ?
                          shift.vehicle_id.display_name
                          : 'N/A' : 'N/A'}}
                          <br>({{shift.vehicle_id!=null ? shift.vehicle_id.plate_number :'N/A'}})
                          <br>({{shift.vehicle_id!=null ? shift.vehicle_id.vehicle_identity_number :'N/A'}})
                        </td>
                        <td>/{{shift.shift_details_id!=null ? shift.shift_details_id.free_rides ?
                          shift.shift_details_id.free_rides
                          : 'N/A' : 'N/A'}}</td>
                        <td>
                          <table aria-describedby="Manage Company" *ngIf="shift.shift_details_id!=null">
                            <th scope="col" style="width: 50%;">{{shift.shift_details_id!=null ? shift.shift_details_id.payment_type
                          ?shift.shift_details_id.payment_type
                          :'Cash':'Cash'}}
                            </th>
                            <th scope="col" style="width: 50%;"></th>
                            <th scope="col" style="width: 50%;"></th>

                            <tr>
                              <td>
                                <span>Trip Total</span>
                                <br>
                              </td>
                              <td></td>
                              <td>
                                <span>{{shift.shift_details_id!=null ? shift.shift_details_id.total.$numberDecimal:'NA'}}
                                </span>&nbsp;&nbsp;
                                <br>
                              </td>
                            </tr>
                            <tr>
                              <td>
                                <span>Credit</span>
                                <br>
                              </td>
                              <td></td>
                              <td>
                                <span>{{shift.shift_details_id!=null ?
                            shift.shift_details_id.credit_total?shift.shift_details_id.credit_total.$numberDecimal:'0':'0'}}</span>&nbsp;&nbsp;
                                <br>
                              </td>
                            </tr>
                            <tr>
                              <td>
                                <span>Cash</span>
                                <br>
                              </td>
                              <td></td>
                              <td>
                                <span>&nbsp;{{shift.shift_details_id!=null ? shift.shift_details_id.cash_trip_total.$numberDecimal:'NA'}}</span>&nbsp;&nbsp;
                                <br>
                              </td>
                            </tr>
                            <tr>
                              <td>
                                <span>Account</span>
                                <br>
                              </td>
                              <td></td>
                              <td>
                                <span>&nbsp;{{shift.shift_details_id!=null ? shift.shift_details_id.account_total?shift.shift_details_id.account_total.$numberDecimal:'0':'0'}}</span>&nbsp;&nbsp;
                                <br>
                              </td>
                            </tr>
                            <tr>
                              <td>
                                <span>Online</span>
                                <br>
                              </td>
                              <td></td>
                              <td>
                                <span>&nbsp;{{shift.shift_details_id!=null ? shift.shift_details_id.card_total?shift.shift_details_id.card_total.$numberDecimal:'0':'0'}}</span>&nbsp;&nbsp;
                                <br>
                              </td>
                            </tr>
                          </table>
                          <span *ngIf="shift.shift_details_id==null"> NA </span>
                        </td>
                        <td *ngIf="shift.shift_details_id!=null">
                          <div>
                            <table aria-describedby="Manage Company" *ngIf="shift.shift_details_id.salik!=null">
                              <th scope="col" style="width: 40%;">Name </th>
                              <th scope="col" style="width: 20%;"></th>
                              <th scope="col" style="width: 40%;"> Price </th>
                              <tr *ngFor="let data of shift.shift_details_id.salik">
                                <td>
                                  {{data.name}}
                                </td>
                                <td>
                                </td>
                                <td>
                                  {{data.amt}}
                                </td>
                              </tr>
                            </table>
                          </div>
                          <span *ngIf="shift.shift_details_id.salik == null">NA</span>
                        </td>
                        <td *ngIf="shift.shift_details_id==null">
                        </td>
                        <td>
                          <table aria-describedby="Manage Company" *ngIf="shift.shift_details_id != null">
                            <th scope="col" style="width: 40%;"></th>
                            <th scope="col" style="width: 30%;"></th>
                            <th scope="col" style="width: 30%;"></th>
                            <tr>
                              <td>
                                Drive
                              </td>
                              <td>
                              </td>
                              <td>
                                {{shift.shift_details_id.drive?shift.shift_details_id.drive.$numberDecimal:'0'}}
                              </td>
                            </tr>
                            <tr>
                              <td>
                                Service
                              </td>
                              <td></td>
                              <td>
                                {{shift.shift_details_id.total_other_service?shift.shift_details_id.total_other_service.$numberDecimal:'0'}}

                              </td>
                            </tr>
                            <tr>
                              <td>
                                Payment Extra
                              </td>
                              <td>
                              </td>
                              <td>
                                {{shift.shift_details_id.total_salik?shift.shift_details_id.total_salik.$numberDecimal:'0'}}
                              </td>
                            </tr>
                            <tr>
                              <td>
                                Total
                              </td>
                              <td>
                              </td>
                              <td>
                                {{shift.shift_details_id.total?shift.shift_details_id.total.$numberDecimal:'0'}}
                              </td>
                            </tr>

                          </table>
                          <span *ngIf="shift.shift_details_id == null"> NA </span>
                        </td>
                        <td>
                          <strong>{{shift.shift_details_id!=null ? shift.shift_details_id.cash_trip_total ?
                    shift.shift_details_id.cash_trip_total.$numberDecimal
                    : 'N/A' : 'N/A'}}</strong>
                        </td>
                        <td> {{shift.shift_details_id!=null ? shift.shift_details_id.payed ?
                  shift.shift_details_id.payed.$numberDecimal
                  : 'N/A' : 'N/A'}}</td>
                        <td>
                          {{shift.shift_details_id!=null ? shift.shift_details_id.cash_trip_total ?
                  shift.shift_details_id.cash_trip_total.$numberDecimal
                  : 'N/A' : 'N/A'}}
                        </td>
                        <td>
                          <span *ngIf="true == shift.empty_status;">
                            <button type="get" class="btn btn-sm btn-primary"
                              [routerLink]="['/admin/orders/shifts' , shift._id]">Open</button>
                          </span>
                          <span *ngIf="true == shift.empty_status;">
                            <span *ngIf="2 == shift.approve_status;" ng-hide='!shift.visibility'>
                              <button type="get" class="btn btn-sm btn-primary" (click)="openDialog(shift._id, i)"
                                style="width: 5em;">
                                Approve </button>
                            </span>
                          </span>
                          <span *ngIf="1 ==shift.approve_status;"> Shift Approved </span>
                        </td>
                      </tr>
                    </tbody>
                  </table>
                </div>
                <br>
                <div class="container-fluid" *ngIf="allShiftsLength>0">
                  <div class="row">
                    <div class="cols-md-12 text-center dataTables_info1">
                      <div *ngIf="del">
                        <ngb-pagination [collectionSize]="allShiftsLength" (pageChange)="pagingAgent($event)"
                          [(page)]="pNo" [pageSize]="itemsPerPage" aria-label="Default pagination" [maxSize]="5"
                          [boundaryLinks]="true"></ngb-pagination>
                      </div>
                      <div *ngIf="!del">
                        <ngb-pagination [collectionSize]="allShiftsLength" (pageChange)="pagingAgent($event)"
                          [(page)]="pNo" [pageSize]="itemsPerPage" aria-label="Default pagination" [maxSize]="5"
                          [boundaryLinks]="true"></ngb-pagination>
                      </div>
                    </div>
                  </div>
                </div>
                <div class="container-fluid" *ngIf="allShiftsLength==0">
                  <div class="row">
                    <div class="dataTables_info1">
                      <div class="col-md-4 form-group" style="text-align:center;margin-left:32%">
                        No records found.
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>